/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COMISSAO                                                 */
/* Tabela : COMISSAO                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 26/03/2004 - Raphael Freitas Pinheiro                                      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_COMISSAO
BEFORE INSERT OR UPDATE OR DELETE
ON COMISSAO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCOMI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCOMISSAO,0) <> NVL(:NEW.CDCOMISSAO,0)) OR
         (NVL(:OLD.NMCOMISSAO,0) <> NVL(:NEW.NMCOMISSAO,0)) THEN
         :NEW.DTULTATUCOMI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('COMISSAO', '', 'CDCOMISSAO='||:OLD.CDCOMISSAO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE COMISSAO MODIFY DTULTATUCOMI DEFAULT SYSDATE
/

