/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPTOTAPROD                                             */
/* Tabela : GRUPTOTAPROD                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 28/09/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_GRUPTOTAPROD
BEFORE INSERT OR UPDATE OR DELETE
ON GRUPTOTAPROD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGRTO  := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDGRTOTAPROD,0 ) <> NVL(:NEW.CDGRTOTAPROD,0)) OR
         (NVL(:OLD.NMGRTOTAPROD,0 ) <> NVL(:NEW.NMGRTOTAPROD,0)) THEN
         :NEW.DTULTATUGRTO  := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('GRUPTOTAPROD', '','CDGRTOTAPROD='||:OLD.CDGRTOTAPROD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE GRUPTOTAPROD MODIFY DTULTATUGRTO DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_GRUPTOTAPROD','5.05.003'); END;
/

