function ImageUploaderController($scope, templateManager) {

	var self = this;

	var widgetAccessorDescriptor = {
		get: function() {
			return $scope.widget;
		}
	};

	var fieldAcessosDescriptor = {
		get: function() {
			return $scope.field;
		}
	};

	Object.defineProperty(self, "widget", widgetAccessorDescriptor);
	Object.defineProperty(self, "field", fieldAcessosDescriptor);

	/***************************************************
	 * Functions used by template
	 ***************************************************/
	this.getChooseFileText = function() {
		return self.field.chooseFileText || "Choose a file...";
	};

	this.getNoFileSelectedText = function() {
		return self.field.noFileSelectedText || "No file selected.";
	};

	this.getCurrentThumbnail = function() {
		var currentThumbnail = "//:0";
		if (typeof self.widget.currentRow[self.field.name] === "string") {
			var root = templateManager.project.fileServiceBaseUrl || "";
			currentThumbnail = root + self.widget.currentRow[self.field.name];
		} else if (Array.isArray(self.widget.currentRow[self.field.name]) && self.widget.currentRow[self.field.name].length > 0) {
			currentThumbnail = self.widget.currentRow[self.field.name][0].b64File;
		}

		return currentThumbnail;
	};

	this.isVisibleInCurrentFormTemplate = function() {};

	this.isEditMode = function() {
		return self.widget.mode === 'edit';
	};

	this.deselectFile = function(file) {
		self.widget.currentRow[self.field.name].splice(self.widget.currentRow[self.field.name].indexOf(file), 1);
		self.field.fileList = self.widget.currentRow[self.field.name];

		_callChangeEvent();
		_callAfterDeselectFileEvent();
	};

	function _callChangeEvent() {
		if (self.field.change) {
			self.field.change();
		}
	}

	function _callAfterDeselectFileEvent() {
		if (self.field.afterDeselectFile) {
			self.field.afterDeselectFile();
		}
	}
}